<template>
  <div class='app-container'>
    <!-- 搜索 -->
    <el-form inline size="mini">
      <el-form-item label="活动名称：">
        <el-input v-model="form.name" placeholder="请输入活动名称" clearable />
      </el-form-item>
      <el-form-item label="当前状态：">
        <el-select v-model="form.activityState" placeholder="请选择当前状态" clearable>
          <el-option v-for="item in currentOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="上下架状态：">
        <el-select v-model="form.status" placeholder="请选择上下架状态" clearable>
          <el-option v-for="item in disabledOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="getSearch">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="getRefresh">重置</el-button>
        <el-button type="primary" icon="el-icon-plus" plain @click="getDetail"
          v-hasPermi="['operation:activity:add']">新增</el-button>
      </el-form-item>
    </el-form>
    <!-- 列表 -->
    <el-table :data="tableData" v-loading="loading">
      <el-table-column label="序号" align="center" type="index" />
      <el-table-column label="活动id" align="center" prop="id" show-overflow-tooltip />
      <el-table-column label="活动名称" align="center" prop="name" show-overflow-tooltip />
      <el-table-column label="活动图片" align="center" width="100px">
        <template slot-scope="scope">
          <el-image :src="scope.row.pic" />
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="有效时间" align="center" show-overflow-tooltip>
        <template slot-scope="scope">
          {{ scope.row.timeList.join(' - ') }}
        </template>
      </el-table-column>
      <el-table-column label="当前状态" align="center" :formatter="activityFormatter" width="150px" />
      <el-table-column label="上下架状态" align="center" :formatter="statusFormatter" width="150px" />
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button type="text" @click="getDetail(scope.row, true)">查看</el-button>
          <el-button type="text" v-if="scope.row.status === 0" @click="getChange(scope.row.id, 1, '下架')"
            v-hasPermi="['operation:activity:down']">下架</el-button>
          <span v-else style="margin: 0 10px">
            <el-button v-if="scope.row.activityState !== 2" type="text" @click="getDetail(scope.row)"
              v-hasPermi="['operation:activity:edit']">编辑</el-button>
            <el-button v-if="scope.row.activityState !== 2" type="text" @click="getChange(scope.row.id, 0, '上架')"
              v-hasPermi="['operation:activity:up']">上架</el-button>
            <el-button type="delete" @click="getDelete(scope.row)"
              v-hasPermi="['operation:activity:delete']">删除</el-button>
          </span>
          <el-button type="text" v-clipboard:copy="scope.row.copyUrl" v-clipboard:success="getCopy"
            v-hasPermi="['operation:activity:copy']">复制链接</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" :page.sync="form.pageNum" :limit.sync="form.pageSize"
      @pagination="getList" />
  </div>
</template>

<script>
import { list, change } from '@/api/operation/activity'
import { currentMixin, disabledMixin } from '@/mixin/index'
export default {
  mixins: [currentMixin, disabledMixin],
  data() {
    return {
      // 遮罩层
      loading: false,
      // 表单
      form: {
        pageNum: 1,
        pageSize: 10
      },
      // 总数据
      total: 0,
      // 列表
      tableData: []
    }
  },
  mounted() {
    this.getList()
  },
  methods: {
    // 列表
    getList() {
      this.loading = true
      list(this.form).then(res => {
        if (res.code === 0) {
          this.tableData = res.data.records
          this.total = res.data.total
          this.loading = false
        }
      })
    },

    // 搜索
    getSearch() {
      this.form.pageNum = 1
      this.getList()
    },

    // 重置
    getRefresh() {
      this.form = {
        pageNum: 1,
        pageSize: 10
      }
      this.getList()
    },

    // 详情
    getDetail(row, boolean) {
      this.$router.push({
        path: `/operation/activity/detail`,
        query: {
          id: row.id,
          boolean: boolean,
          activityState: row.activityState
        }
      })
    },

    // 上下架
    getChange(id, status, title) {
      change(id, status).then(res => {
        if (res.code === 0) {
          this.$message.success(`${title}成功！`)
          this.getList()
        }
      })
    },

    // 删除
    getDelete(row) {
      this.$confirm(`是否删除${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        change(row.id, 2).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功！')
            this.getList()
          }
        })
      })
    },

    // 复制链接
    getCopy() {
      this.$message.success('复制成功！')
    },

    // 字典翻译
    activityFormatter(row) {
      return this.selectDictLabel(this.currentOptions, row.activityState)
    },

    statusFormatter(row) {
      return this.selectDictLabel(this.disabledOptions, row.status)
    }
  }
}
</script>